diff --git a/sys/compat/mach/mach_port.c b/sys/compat/mach/mach_port.c
index a891600..0b0efc9 100644
--- a/sys/compat/mach/mach_port.c
+++ b/sys/compat/mach/mach_port.c
@@ -1,5 +1,3 @@
-/*	$NetBSD: mach_port.c,v 1.66 2009/03/18 16:00:17 cegger Exp $ */
-
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
  * All rights reserved.
@@ -9,12 +7,12 @@
  *
  * Redistribution and use in source and binary forms, with or without
  * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
+ * are met: 1. Redistributions of source code must retain the above
+ * copyright notice, this list of conditions and the following
+ * disclaimer.  2. Redistributions in binary form must reproduce the
+ * above copyright notice, this list of conditions and the following
+ * disclaimer in the documentation and/or other materials provided
+ * with the distribution.
  *
  * THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
  * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
@@ -29,10 +27,8 @@
  * POSSIBILITY OF SUCH DAMAGE.
  */
 
-#include "opt_compat_darwin.h"
-
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_port.c,v 1.66 2009/03/18 16:00:17 cegger Exp $");
+__FBSDID("$FreeBSD$");
 
 #include <sys/types.h>
 #include <sys/param.h>
@@ -52,7 +48,7 @@ __KERNEL_RCSID(0, "$NetBSD: mach_port.c,v 1.66 2009/03/18 16:00:17 cegger Exp $"
 #include <compat/mach/mach_errno.h>
 #include <compat/mach/mach_notify.h>
 #include <compat/mach/mach_services.h>
-#include <compat/mach/mach_syscallargs.h>
+#include <compat/mach/mach_proto.h>
 
 #ifdef COMPAT_DARWIN
 #include <compat/darwin/darwin_exec.h>
@@ -68,53 +64,53 @@ struct mach_port *mach_io_master_port;
 struct mach_port *mach_saved_bootstrap_port;
 
 int
-mach_sys_reply_port(struct lwp *l, const void *v, register_t *retval)
+mach_sys_reply_port(struct thread *td, const void *v)
 {
 	struct mach_right *mr;
 
-	mr = mach_right_get(mach_port_get(), l, MACH_PORT_TYPE_RECEIVE, 0);
-	*retval = (register_t)mr->mr_name;
+	mr = mach_right_get(mach_port_get(), td, MACH_PORT_TYPE_RECEIVE, 0);
+	td->td_retval[0] = (register_t)mr->mr_name;
 
 	return 0;
 }
 
 int
-mach_sys_thread_self_trap(struct lwp *l, const void *v, register_t *retval)
+mach_sys_thread_self_trap(struct thread *td, const void *v)
 {
 	struct mach_lwp_emuldata *mle;
 	struct mach_right *mr;
 
 	mle = l->l_emuldata;
-	mr = mach_right_get(mle->mle_kernel, l, MACH_PORT_TYPE_SEND, 0);
-	*retval = (register_t)mr->mr_name;
+	mr = mach_right_get(mle->mle_kernel, td, MACH_PORT_TYPE_SEND, 0);
+	td->td_retval[0] = (register_t)mr->mr_name;
 
 	return 0;
 }
 
 
 int
-mach_sys_task_self_trap(struct lwp *l, const void *v, register_t *retval)
+mach_task_self_trap(struct thread *td, const void *v)
 {
 	struct mach_emuldata *med;
 	struct mach_right *mr;
 
-	med = (struct mach_emuldata *)l->l_proc->p_emuldata;
-	mr = mach_right_get(med->med_kernel, l, MACH_PORT_TYPE_SEND, 0);
-	*retval = (register_t)mr->mr_name;
+	med = (struct mach_emuldata *)td->td_proc->p_emuldata;
+	mr = mach_right_get(med->med_kernel, td, MACH_PORT_TYPE_SEND, 0);
+	td->td_retval[0] = (register_t)mr->mr_name;
 
 	return 0;
 }
 
 
 int
-mach_sys_host_self_trap(struct lwp *l, const void *v, register_t *retval)
+mach_sys_host_self_trap(struct thread *td, const void *v)
 {
 	struct mach_emuldata *med;
 	struct mach_right *mr;
 
-	med = (struct mach_emuldata *)l->l_proc->p_emuldata;
-	mr = mach_right_get(med->med_host, l, MACH_PORT_TYPE_SEND, 0);
-	*retval = (register_t)mr->mr_name;
+	med = (struct mach_emuldata *)td->td_proc->p_emuldata;
+	mr = mach_right_get(med->med_host, td, MACH_PORT_TYPE_SEND, 0);
+	td->td_retval[0] = (register_t)mr->mr_name;
 
 	return 0;
 }
@@ -125,12 +121,12 @@ mach_port_deallocate(struct mach_trap_args *args)
 	mach_port_deallocate_request_t *req = args->smsg;
 	mach_port_deallocate_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_port_t mn;
 	struct mach_right *mr;
 
 	mn = req->req_name;
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_REF_RIGHTS)) != NULL)
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_REF_RIGHTS)) != NULL)
 		mach_right_put(mr, MACH_PORT_TYPE_REF_RIGHTS);
 
 	*msglen = sizeof(*rep);
@@ -149,7 +145,7 @@ mach_port_destroy(struct mach_trap_args *args)
 	mach_port_destroy_request_t *req = args->smsg;
 	mach_port_destroy_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_port_t mn;
 	struct mach_right *mr;
 
@@ -158,7 +154,7 @@ mach_port_destroy(struct mach_trap_args *args)
 #endif
 	mn = req->req_name;
 	if ((mr = mach_right_check(mn,
-	    l, MACH_PORT_TYPE_ALL_RIGHTS)) != NULL) {
+	    td, MACH_PORT_TYPE_ALL_RIGHTS)) != NULL) {
 		MACH_PORT_UNREF(mr->mr_port);
 		mr->mr_port = NULL;
 		mach_right_put(mr, MACH_PORT_TYPE_ALL_RIGHTS);
@@ -180,22 +176,22 @@ mach_port_allocate(struct mach_trap_args *args)
 	mach_port_allocate_request_t *req = args->smsg;
 	mach_port_allocate_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	struct mach_right *mr;
 	struct mach_port *mp;
 
 	switch (req->req_right) {
 	case MACH_PORT_RIGHT_RECEIVE:
 		mp = mach_port_get();
-		mr = mach_right_get(mp, l, MACH_PORT_TYPE_RECEIVE, 0);
+		mr = mach_right_get(mp, td, MACH_PORT_TYPE_RECEIVE, 0);
 		break;
 
 	case MACH_PORT_RIGHT_DEAD_NAME:
-		mr = mach_right_get(NULL, l, MACH_PORT_TYPE_DEAD_NAME, 0);
+		mr = mach_right_get(NULL, td, MACH_PORT_TYPE_DEAD_NAME, 0);
 		break;
 
 	case MACH_PORT_RIGHT_PORT_SET:
-		mr = mach_right_get(NULL, l, MACH_PORT_TYPE_PORT_SET, 0);
+		mr = mach_right_get(NULL, td, MACH_PORT_TYPE_PORT_SET, 0);
 		break;
 
 	default:
@@ -222,7 +218,7 @@ mach_port_insert_right(struct mach_trap_args *args)
 	mach_port_insert_right_request_t *req = args->smsg;
 	mach_port_insert_right_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_port_t name;
 	mach_port_t right;
 	struct mach_right *mr;
@@ -232,7 +228,7 @@ mach_port_insert_right(struct mach_trap_args *args)
 	right = req->req_poly.name;
 	nmr = NULL;
 
-	mr = mach_right_check(right, l, MACH_PORT_TYPE_ALL_RIGHTS);
+	mr = mach_right_check(right, td, MACH_PORT_TYPE_ALL_RIGHTS);
 	if (mr == NULL)
 		return mach_msg_error(args, EPERM);
 
@@ -241,18 +237,18 @@ mach_port_insert_right(struct mach_trap_args *args)
 	case MACH_MSG_TYPE_MOVE_SEND:
 	case MACH_MSG_TYPE_COPY_SEND:
 		nmr = mach_right_get(mr->mr_port,
-		    l, MACH_PORT_TYPE_SEND, name);
+		    td, MACH_PORT_TYPE_SEND, name);
 		break;
 
 	case MACH_MSG_TYPE_MAKE_SEND_ONCE:
 	case MACH_MSG_TYPE_MOVE_SEND_ONCE:
 		nmr = mach_right_get(mr->mr_port,
-		    l, MACH_PORT_TYPE_SEND_ONCE, name);
+		    td, MACH_PORT_TYPE_SEND_ONCE, name);
 		break;
 
 	case MACH_MSG_TYPE_MOVE_RECEIVE:
 		nmr = mach_right_get(mr->mr_port,
-		    l, MACH_PORT_TYPE_RECEIVE, name);
+		    td, MACH_PORT_TYPE_RECEIVE, name);
 		break;
 
 	default:
@@ -277,12 +273,12 @@ mach_port_type(struct mach_trap_args *args)
 	mach_port_type_request_t *req = args->smsg;
 	mach_port_type_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_port_t mn;
 	struct mach_right *mr;
 
 	mn = req->req_name;
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
 		return mach_msg_error(args, EPERM);
 
 	*msglen = sizeof(*rep);
@@ -336,7 +332,7 @@ mach_port_get_attributes(struct mach_trap_args *args)
 	mach_port_get_attributes_request_t *req = args->smsg;
 	mach_port_get_attributes_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_port_t mn;
 	struct mach_right *mr;
 
@@ -345,7 +341,7 @@ mach_port_get_attributes(struct mach_trap_args *args)
 		return mach_msg_error(args, EINVAL);
 
 	mn = req->req_msgh.msgh_remote_port;
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
 		return mach_msg_error(args, EPERM);
 
 	switch (req->req_flavor) {
@@ -440,18 +436,18 @@ mach_port_move_member(struct mach_trap_args *args)
 	mach_port_move_member_request_t *req = args->smsg;
 	mach_port_move_member_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
-	struct mach_emuldata *med = l->l_proc->p_emuldata;
+	struct thread *td = args->td;
+	struct mach_emuldata *med = td->td_proc->p_emuldata;
 	mach_port_t member = req->req_member;
 	mach_port_t after = req->req_after;
 	struct mach_right *mrr;
 	struct mach_right *mrs;
 
-	mrr = mach_right_check(member, l, MACH_PORT_TYPE_RECEIVE);
+	mrr = mach_right_check(member, td, MACH_PORT_TYPE_RECEIVE);
 	if (mrr == NULL)
 		return mach_msg_error(args, EPERM);
 
-	mrs = mach_right_check(after, l, MACH_PORT_TYPE_PORT_SET);
+	mrs = mach_right_check(after, td, MACH_PORT_TYPE_PORT_SET);
 	if (mrs == NULL)
 		return mach_msg_error(args, EPERM);
 
@@ -482,7 +478,7 @@ mach_port_request_notification(struct mach_trap_args *args)
 {
 	mach_port_request_notification_request_t *req = args->smsg;
 	mach_port_request_notification_reply_t *rep = args->rmsg;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	size_t *msglen = args->rsize;
 	mach_port_t mn;
 	struct mach_right *nmr;
@@ -495,11 +491,11 @@ mach_port_request_notification(struct mach_trap_args *args)
 	    req->req_notify.name, mn = req->req_name);
 #endif
 	mn = req->req_notify.name;
-	if ((nmr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
+	if ((nmr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
 		return mach_msg_error(args, EINVAL);
 
 	mn = req->req_name;
-	if ((tmr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
+	if ((tmr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
 		return mach_msg_error(args, EINVAL);
 
 #ifdef DEBUG_MACH
@@ -516,13 +512,13 @@ mach_port_request_notification(struct mach_trap_args *args)
 	case MACH_NOTIFY_DESTROYED_MSGID:
 		oldnmr = tmr->mr_notify_destroyed;
 		tmr->mr_notify_destroyed = mach_right_get(nmr->mr_port,
-		    l, MACH_PORT_TYPE_SEND_ONCE, req->req_notify.name);
+		    td, MACH_PORT_TYPE_SEND_ONCE, req->req_notify.name);
 		break;
 
 	case MACH_NOTIFY_NO_SENDERS_MSGID:
 		oldnmr = tmr->mr_notify_no_senders;
 		tmr->mr_notify_no_senders = mach_right_get(nmr->mr_port,
-		    l, MACH_PORT_TYPE_SEND_ONCE, req->req_notify.name);
+		    td, MACH_PORT_TYPE_SEND_ONCE, req->req_notify.name);
 		tmr->mr_notify_no_senders->mr_port->mp_datatype =
 		    MACH_MP_NOTIFY_SYNC;
 		tmr->mr_notify_no_senders->mr_port->mp_data = (void *)
@@ -532,7 +528,7 @@ mach_port_request_notification(struct mach_trap_args *args)
 	case MACH_NOTIFY_DEAD_NAME_MSGID:
 		oldnmr = tmr->mr_notify_dead_name;
 		tmr->mr_notify_dead_name = mach_right_get(nmr->mr_port,
-		    l, MACH_PORT_TYPE_SEND_ONCE, req->req_notify.name);
+		    td, MACH_PORT_TYPE_SEND_ONCE, req->req_notify.name);
 		break;
 
 	case MACH_NOTIFY_SEND_ONCE_MSGID:
@@ -566,13 +562,13 @@ mach_port_get_refs(struct mach_trap_args *args)
 	mach_port_get_refs_request_t *req = args->smsg;
 	mach_port_get_refs_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_port_t mn;
 	struct mach_right *mr;
 	mach_port_right_t right = req->req_right;
 
 	mn = req->req_name;
-	if ((mr = mach_right_check(mn, l, right)) == NULL)
+	if ((mr = mach_right_check(mn, td, right)) == NULL)
 		return mach_msg_error(args, EINVAL);
 
 	*msglen = sizeof(*rep);
@@ -593,13 +589,13 @@ mach_port_mod_refs(struct mach_trap_args *args)
 	mach_port_mod_refs_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
 #if 0
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	mach_port_t mn;
 	struct mach_right *mr;
 	mach_port_right_t right = req->req_right;
 
 	mn = req->req_name;
-	if ((mr = mach_right_check(mn, l, right)) == NULL)
+	if ((mr = mach_right_check(mn, td, right)) == NULL)
 		return mach_msg_error(args, EINVAL);
 
 	/*
@@ -680,7 +676,7 @@ mach_port_put(struct mach_port *mp)
 	rw_destroy(&mp->mp_msglock);
 
 	if (mp->mp_flags & MACH_MP_DATA_ALLOCATED)
-		free(mp->mp_data, M_EMULDATA);
+		free(mp->mp_data, M_MACH);
 
 	pool_put(&mach_port_pool, mp);
 
@@ -688,7 +684,7 @@ mach_port_put(struct mach_port *mp)
 }
 
 struct mach_right *
-mach_right_get(struct mach_port *mp, struct lwp *l, int type, mach_port_t hint)
+mach_right_get(struct mach_port *mp, struct thread *td, int type, mach_port_t hint)
 {
 	struct mach_right *mr;
 	struct mach_emuldata *med;
@@ -698,7 +694,7 @@ mach_right_get(struct mach_port *mp, struct lwp *l, int type, mach_port_t hint)
 	if (type == 0)
 		uprintf("mach_right_get: right = 0\n");
 #endif
-	med = (struct mach_emuldata *)l->l_proc->p_emuldata;
+	med = (struct mach_emuldata *)td->td_proc->p_emuldata;
 
 	if (mp != NULL)
 		MACH_PORT_REF(mp);
@@ -888,7 +884,7 @@ mach_right_put_exclocked(struct mach_right *mr, int right)
  * Check that a process has a given right.
  */
 struct mach_right *
-mach_right_check(mach_port_t mn, struct lwp *l, int type)
+mach_right_check(mach_port_t mn, struct thread *td, int type)
 {
 	struct mach_right *cmr;
 	struct mach_emuldata *med;
@@ -896,7 +892,7 @@ mach_right_check(mach_port_t mn, struct lwp *l, int type)
 	if ((mn == 0) || (mn == -1) || (l == NULL))
 		return NULL;
 
-	med = (struct mach_emuldata *)l->l_proc->p_emuldata;
+	med = (struct mach_emuldata *)td->td_proc->p_emuldata;
 
 	rw_enter(&med->med_rightlock, RW_READER);
 
@@ -925,13 +921,13 @@ mach_right_check(mach_port_t mn, struct lwp *l, int type)
  * Right lists should be locked.
  */
 mach_port_t
-mach_right_newname(struct lwp *l, mach_port_t hint)
+mach_right_newname(struct thread *td, mach_port_t hint)
 {
 	struct mach_emuldata *med;
 	struct mach_right *mr;
 	mach_port_t newname = -1;
 
-	med = l->l_proc->p_emuldata;
+	med = td->td_proc->p_emuldata;
 
 	if (hint == 0)
 		hint = med->med_nextright;
diff --git a/sys/compat/mach/mach_port.h b/sys/compat/mach/mach_port.h
index 8399791..4c9cb6b 100644
--- a/sys/compat/mach/mach_port.h
+++ b/sys/compat/mach/mach_port.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_port.h,v 1.40 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
@@ -31,6 +31,8 @@
 
 #ifndef	_MACH_PORT_H_
 #define	_MACH_PORT_H_
+#include <sys/lock.h>
+#include <sys/rwlock.h>
 
 #define MACH_PORT_REF(mp)	(mp)->mp_refcount++
 #define MACH_PORT_UNREF(mp)	if (--(mp)->mp_refcount <= 0) mach_port_put(mp)
@@ -294,7 +296,7 @@ extern struct mach_port *mach_saved_bootstrap_port;
 /* In-kernel Mach port right description */
 struct mach_right {
 	mach_port_t mr_name;		/* The right name */
-	struct lwp *mr_lwp;		/* points back to struct lwp */
+	struct thread *mr_lwp;		/* points back to struct thread */
 	int mr_type;			/* right type (recv, send, sendonce) */
 	LIST_ENTRY(mach_right) mr_list; /* Right list for a process */
 	int mr_refcount;		/* Reference count */
@@ -314,13 +316,13 @@ struct mach_right {
 	struct mach_right *mr_sethead;	/* Points back to right set */
 };
 
-mach_port_t mach_right_newname(struct lwp *, mach_port_t);
+mach_port_t mach_right_newname(struct thread *, mach_port_t);
 struct mach_right *mach_right_get(struct mach_port *,
-    struct lwp *, int, mach_port_t);
+    struct thread *, int, mach_port_t);
 void mach_right_put(struct mach_right *, int);
 void mach_right_put_shlocked(struct mach_right *, int);
 void mach_right_put_exclocked(struct mach_right *, int);
-struct mach_right *mach_right_check(mach_port_t, struct lwp *, int);
+struct mach_right *mach_right_check(mach_port_t, struct thread *, int);
 
 /* In-kernel Mach port description */
 struct mach_port {
@@ -328,7 +330,7 @@ struct mach_port {
 	int mp_count;			/* Count of queued messages */
 	TAILQ_HEAD(mp_msglist,		/* Queue pending messages */
 	    mach_message) mp_msglist;
-	krwlock_t mp_msglock;		/* Lock for the queue */
+	struct rwlock mp_msglock;		/* Lock for the queue */
 	int mp_refcount;		/* Reference count */
 	int mp_flags;			/* Flags, see below */
 	int mp_datatype;		/* Type of field mp_data, see below */
@@ -341,7 +343,7 @@ struct mach_port {
 
 /* mp_datatype for struct mach_port */
 #define	MACH_MP_NONE		0x0	/* No data */
-#define MACH_MP_LWP		0x1	/* (struct lwp *) */
+#define MACH_MP_LWP		0x1	/* (struct thread *) */
 #define MACH_MP_DEVICE_ITERATOR	0x2	/* (struct mach_device_iterator *) */
 #define MACH_MP_IOKIT_DEVCLASS	0x3	/* (struct mach_iokit_devclass *) */
 #define MACH_MP_PROC		0x4	/* (struct proc *) */
@@ -354,7 +356,7 @@ void mach_port_init(void);
 struct mach_port *mach_port_get(void);
 void mach_port_put(struct mach_port *);
 void mach_remove_recvport(struct mach_port *);
-void mach_add_recvport(struct mach_port *, struct lwp *);
+void mach_add_recvport(struct mach_port *, struct thread *);
 int mach_port_check(struct mach_port *);
 #ifdef DEBUG_MACH
 void mach_debug_port(void);
diff --git a/sys/compat/mach/mach_semaphore.c b/sys/compat/mach/mach_semaphore.c
index 327c893..6953b1a 100644
--- a/sys/compat/mach/mach_semaphore.c
+++ b/sys/compat/mach/mach_semaphore.c
@@ -1,5 +1,3 @@
-/*	$NetBSD: mach_semaphore.c,v 1.19 2008/04/28 20:23:44 martin Exp $ */
-
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
  * All rights reserved.
@@ -30,16 +28,17 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_semaphore.c,v 1.19 2008/04/28 20:23:44 martin Exp $");
+__FBSDID("$FreeBSD$");
 
 #include <sys/types.h>
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/signal.h>
-#include <sys/pool.h>
-#include <sys/rwlock.h>
+#include <sys/lock.h>
 #include <sys/malloc.h>
+#include <sys/pool.h>
 #include <sys/proc.h>
+#include <sys/rwlock.h>
 
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_message.h>
@@ -48,7 +47,7 @@ __KERNEL_RCSID(0, "$NetBSD: mach_semaphore.c,v 1.19 2008/04/28 20:23:44 martin E
 #include <compat/mach/mach_errno.h>
 #include <compat/mach/mach_port.h>
 #include <compat/mach/mach_services.h>
-#include <compat/mach/mach_syscallargs.h>
+#include <compat/mach/mach_proto.h>
 
 /* Semaphore list, lock, pools */
 static LIST_HEAD(mach_semaphore_list, mach_semaphore) mach_semaphore_list;
@@ -65,7 +64,7 @@ static void mach_waiting_lwp_put
     (struct mach_waiting_lwp *, struct mach_semaphore *, int);
 
 int
-mach_sys_semaphore_wait_trap(struct lwp *l, const struct mach_sys_semaphore_wait_trap_args *uap, register_t *retval)
+mach_sys_semaphore_wait_trap(struct thread *td, struct mach_sys_semaphore_wait_trap_args *uap)
 {
 	/* {
 		syscallarg(mach_port_name_t) wait_name;
@@ -76,8 +75,8 @@ mach_sys_semaphore_wait_trap(struct lwp *l, const struct mach_sys_semaphore_wait
 	mach_port_t mn;
 	int blocked = 0;
 
-	mn = SCARG(uap, wait_name);
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == 0)
+	mn = uap->wait_name);
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == 0)
 		return EPERM;
 
 	if (mr->mr_port->mp_datatype != MACH_MP_SEMAPHORE)
@@ -101,7 +100,7 @@ mach_sys_semaphore_wait_trap(struct lwp *l, const struct mach_sys_semaphore_wait
 }
 
 int
-mach_sys_semaphore_signal_trap(struct lwp *l, const struct mach_sys_semaphore_signal_trap_args *uap, register_t *retval)
+mach_sys_semaphore_signal_trap(struct thread *td, struct mach_sys_semaphore_signal_trap_args *uap)
 {
 	/* {
 		syscallarg(mach_port_name_t) signal_name;
@@ -112,8 +111,8 @@ mach_sys_semaphore_signal_trap(struct lwp *l, const struct mach_sys_semaphore_si
 	mach_port_t mn;
 	int unblocked = 0;
 
-	mn = SCARG(uap, signal_name);
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == 0)
+	mn = uap->signal_name);
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == 0)
 		return EPERM;
 
 	if (mr->mr_port->mp_datatype != MACH_MP_SEMAPHORE)
@@ -142,7 +141,7 @@ mach_semaphore_create(struct mach_trap_args *args)
 	mach_semaphore_create_request_t *req = args->smsg;
 	mach_semaphore_create_reply_t *rep = args->rmsg;
 	size_t *msglen = args->rsize;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	struct mach_semaphore *ms;
 	struct mach_port *mp;
 	struct mach_right *mr;
@@ -153,7 +152,7 @@ mach_semaphore_create(struct mach_trap_args *args)
 	mp->mp_datatype = MACH_MP_SEMAPHORE;
 	mp->mp_data = (void *)ms;
 
-	mr = mach_right_get(mp, l, MACH_PORT_TYPE_SEND, 0);
+	mr = mach_right_get(mp, td, MACH_PORT_TYPE_SEND, 0);
 
 	*msglen = sizeof(*rep);
 	mach_set_header(rep, req, *msglen);
@@ -168,14 +167,14 @@ mach_semaphore_destroy(struct mach_trap_args *args)
 {
 	mach_semaphore_destroy_request_t *req = args->smsg;
 	mach_semaphore_destroy_reply_t *rep = args->rmsg;
-	struct lwp *l = args->l;
+	struct thread *td = args->td;
 	size_t *msglen = args->rsize;
 	struct mach_semaphore *ms;
 	struct mach_right *mr;
 	mach_port_t mn;
 
 	mn = req->req_sem.name;
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == 0)
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == 0)
 		return mach_msg_error(args, EPERM);
 
 	if (mr->mr_port->mp_datatype != MACH_MP_SEMAPHORE)
@@ -248,7 +247,7 @@ mach_semaphore_put(struct mach_semaphore *ms)
 }
 
 static struct mach_waiting_lwp *
-mach_waiting_lwp_get(struct lwp *l, struct mach_semaphore *ms)
+mach_waiting_lwp_get(struct thread *td, struct mach_semaphore *ms)
 {
 	struct mach_waiting_lwp *mwl;
 
@@ -281,7 +280,7 @@ mach_waiting_lwp_put(struct mach_waiting_lwp *mwl, struct mach_semaphore *ms, in
  * can be some memory leaks here.
  */
 void
-mach_semaphore_cleanup(struct lwp *l)
+mach_semaphore_cleanup(struct thread *td)
 {
 	struct mach_semaphore *ms;
 	struct mach_waiting_lwp *mwl;
@@ -304,7 +303,7 @@ mach_semaphore_cleanup(struct lwp *l)
 }
 
 int
-mach_sys_semaphore_wait_signal_trap(struct lwp *l, const struct mach_sys_semaphore_wait_signal_trap_args *uap, register_t *retval)
+mach_sys_semaphore_wait_signal_trap(struct thread *td, struct mach_sys_semaphore_wait_signal_trap_args *uap)
 {
 	/* {
 		syscallarg(mach_port_name_t) wait_name;
@@ -314,12 +313,12 @@ mach_sys_semaphore_wait_signal_trap(struct lwp *l, const struct mach_sys_semapho
 	struct mach_sys_semaphore_signal_trap_args cupsig;
 	int error;
 
-	SCARG(&cupsig, signal_name) = SCARG(uap, signal_name);
-	if ((error = mach_sys_semaphore_signal_trap(l, &cupsig, retval)) != 0)
+	&cupsig->signal_name = uap->signal_name;
+	if ((error = mach_sys_semaphore_signal_trap(td, &cupsig)) != 0)
 		return error;
 
-	SCARG(&cupwait, wait_name) = SCARG(uap, wait_name);
-	if ((error = mach_sys_semaphore_wait_trap(l, &cupwait, retval)) != 0)
+	&cupwait->wait_name = uap->wait_name;
+	if ((error = mach_sys_semaphore_wait_trap(td, &cupwait)) != 0)
 		return error;
 
 	return 0;
@@ -327,7 +326,7 @@ mach_sys_semaphore_wait_signal_trap(struct lwp *l, const struct mach_sys_semapho
 
 
 int
-mach_sys_semaphore_signal_thread_trap(struct lwp *l, const struct mach_sys_semaphore_signal_thread_trap_args *uap, register_t *retval)
+mach_sys_semaphore_signal_thread_trap(struct thread *td, struct mach_sys_semaphore_signal_thread_trap_args *uap)
 {
 	/* {
 		syscallarg(mach_port_name_t) signal_name;
@@ -342,8 +341,8 @@ mach_sys_semaphore_signal_thread_trap(struct lwp *l, const struct mach_sys_semap
 	/*
 	 * Get the semaphore
 	 */
-	mn = SCARG(uap, signal_name);
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
+	mn = uap->signal_name);
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
 		return EINVAL;
 
 	if (mr->mr_port->mp_datatype != MACH_MP_SEMAPHORE)
@@ -355,9 +354,9 @@ mach_sys_semaphore_signal_thread_trap(struct lwp *l, const struct mach_sys_semap
 	 * Get the thread, and check that it is waiting for our semaphore
 	 * If no thread was supplied, pick up the first one.
 	 */
-	mn = SCARG(uap, thread);
+	mn = uap->thread);
 	if (mn != 0) {
-		if ((mr = mach_right_check(mn, l,
+		if ((mr = mach_right_check(mn, td,
 		    MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
 			return EINVAL;
 
@@ -395,7 +394,7 @@ mach_sys_semaphore_signal_thread_trap(struct lwp *l, const struct mach_sys_semap
 
 
 int
-mach_sys_semaphore_signal_all_trap(struct lwp *l, const struct mach_sys_semaphore_signal_all_trap_args *uap, register_t *retval)
+mach_sys_semaphore_signal_all_trap(struct thread *td, struct mach_sys_semaphore_signal_all_trap_args *uap)
 {
 	/* {
 		syscallarg(mach_port_name_t) signal_name;
@@ -409,8 +408,8 @@ mach_sys_semaphore_signal_all_trap(struct lwp *l, const struct mach_sys_semaphor
 	/*
 	 * Get the semaphore
 	 */
-	mn = SCARG(uap, signal_name);
-	if ((mr = mach_right_check(mn, l, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
+	mn = uap->signal_name;
+	if ((mr = mach_right_check(mn, td, MACH_PORT_TYPE_ALL_RIGHTS)) == NULL)
 		return EINVAL;
 
 	if (mr->mr_port->mp_datatype != MACH_MP_SEMAPHORE)
diff --git a/sys/compat/mach/mach_semaphore.h b/sys/compat/mach/mach_semaphore.h
index 337ca3e..26b259f 100644
--- a/sys/compat/mach/mach_semaphore.h
+++ b/sys/compat/mach/mach_semaphore.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_semaphore.h,v 1.7 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2002-2003 The NetBSD Foundation, Inc.
@@ -32,6 +32,7 @@
 #ifndef	_MACH_SEMAPHORE_H_
 #define	_MACH_SEMAPHORE_H_
 
+#include <sys/lock.h>
 #include <sys/rwlock.h>
 #include <sys/queue.h>
 
@@ -47,7 +48,7 @@ struct mach_semaphore {
 	int ms_policy;
 	LIST_ENTRY(mach_semaphore) ms_list;
 	TAILQ_HEAD(ms_waiting, mach_waiting_lwp) ms_waiting;
-	krwlock_t ms_lock;
+	struct rwlock ms_lock;
 };
 
 /* semaphore_create */
diff --git a/sys/compat/mach/mach_services.c b/sys/compat/mach/mach_services.c
index bf10124..2ce0fd1 100644
--- a/sys/compat/mach/mach_services.c
+++ b/sys/compat/mach/mach_services.c
@@ -8,7 +8,6 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_services.c,v 1.19 2009/01/13 22:33:10 pooka Exp $");
 
 #include <sys/types.h>
 #include <sys/param.h>
diff --git a/sys/compat/mach/mach_services.h b/sys/compat/mach/mach_services.h
index 4894a3a..49ed48b 100644
--- a/sys/compat/mach/mach_services.h
+++ b/sys/compat/mach/mach_services.h
@@ -8,7 +8,6 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_services.h,v 1.19 2009/01/13 22:33:10 pooka Exp $");
 
 #include <compat/mach/mach_types.h>
 #include <compat/mach/mach_message.h>
diff --git a/sys/compat/mach/mach_services_names.c b/sys/compat/mach/mach_services_names.c
index dd0a3c7..877e637 100644
--- a/sys/compat/mach/mach_services_names.c
+++ b/sys/compat/mach/mach_services_names.c
@@ -9,7 +9,6 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_services_names.c,v 1.16 2009/01/13 22:33:10 pooka Exp $");
 
 struct mach_service_name {
 	int srv_id;
diff --git a/sys/compat/mach/mach_sysctl.c b/sys/compat/mach/mach_sysctl.c
index 07421ee..e5810bd 100644
--- a/sys/compat/mach/mach_sysctl.c
+++ b/sys/compat/mach/mach_sysctl.c
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_sysctl.c,v 1.4 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2004 The NetBSD Foundation, Inc.
@@ -30,7 +30,6 @@
  */
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: mach_sysctl.c,v 1.4 2008/04/28 20:23:44 martin Exp $");
 
 #include <sys/param.h>
 #include <sys/types.h>
diff --git a/sys/compat/mach/mach_sysctl.h b/sys/compat/mach/mach_sysctl.h
index 6f6a422..586bd68 100644
--- a/sys/compat/mach/mach_sysctl.h
+++ b/sys/compat/mach/mach_sysctl.h
@@ -1,4 +1,4 @@
-/*	$NetBSD: mach_sysctl.h,v 1.3 2008/04/28 20:23:44 martin Exp $ */
+/*	$FreeBSD$ */
 
 /*-
  * Copyright (c) 2004 The NetBSD Foundation, Inc.
